---------------------------------------------------
---------------------------------------------------
--  Easy 1 Processor Architecture				 --
--  University of Puerto Rico					 --
--  Mayaguez Campus								 --
--	Department of Computer Engineering			 --
-- 												 --
--	Copyright (c) 2003							 --
--	All rigths reserved.						 --
--										   		 --
--	Prof. Bienvenido Vlez						 --
--	Abdiel Avils								 --
--	Rafael S. Garca							 --
--	Nesmary Hernndez 							 --
-- 	Carlos Prez								 --
---------------------------------------------------
---------------------------------------------------
-- 	[easy1_one_bit_adder.vhd]
--	Easy 1 One Bit Adder
--	This module describes the Easy 1 One Bit Adder.
--	The One Bit Adder receives two bit operands and
--	and one carry, and adds them. The result and
--	carry out are outputs.
---------------------------------------------------	
---------------------------------------------------
--	Libraries declarations
library ieee;
use ieee.std_logic_1164.all;
use easy1_package.all;
--
---------------------------------------------------
--	Entity declaration
--	@abit      	- operand from the A Bus
--	@bbit      	- operand from the Accumulator
--	@cinbit		- carry in bit
--	@coutbit	- carry out bit
--	@sumbit		- result
--
entity easy1_one_bit_adder is
	
	port(
	abit	:	in std_logic:='0';
	bbit	:	in std_logic:='0';
	cinbit	:	in std_logic:='0';
	coutbit	:	out std_logic:='0';
	sumbit	:	out std_logic:='0');
	
end easy1_one_bit_adder;
--
----------------------------------------------------
--	Architecture declaration
--		This process implements a one bit adder
--
architecture easy1_one_bit_add_arq of easy1_one_bit_adder is
begin
	process(abit,bbit,cinbit)
	begin
		sumbit <= (abit xor bbit) xor cinbit after DELAY_1_LEVEL;
		coutbit <= (abit and bbit) or (abit and cinbit) or (bbit and cinbit) after DELAY_1_LEVEL;
	end process;
end easy1_one_bit_add_arq;
----------------------------------------------------
----------------------------------------------------
