---------------------------------------------------
---------------------------------------------------
--  Easy 1 Processor Architecture				 --
--  University of Puerto Rico					 --
--  Mayaguez Campus								 --
--	Department of Computer Engineering			 --
-- 												 --
--	Copyright (c) 2003 							 --
--	All rigths reserved.						 --
--										   		 --
--	Prof. Bienvenido Vlez						 --
--	Abdiel Avils								 --
--	Rafael S. Garca							 --
--	Nesmary Hernndez 							 --
-- 	Carlos Prez								 --
---------------------------------------------------
---------------------------------------------------
-- 	[easy1_reg_ms.vhd]
--	Easy 1 Master/Slave Register
--	Behavioral description of a 16 bit
--	Master/Slave Register
---------------------------------------------------	
---------------------------------------------------
--	Libraries declarations
library ieee ;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all; 
use easy1_package.all;
--
---------------------------------------------------
--	Entity declaration
--	@clock  	- clock source
--	@input  	- data input
--	@load		- load signal
--	@clear		- clear signal 
--	@o			- register output
--
entity easy1_reg_ms is
	
	port(
		clock		:	in std_logic:='0';
		input		:	in std_logic_vector(15 downto 0):=X"0000";
		load		:	in std_logic:='0';
		clear		:	in std_logic:='0';
		o			:	out std_logic_vector(15 downto 0):=X"0000"
		);
end easy1_reg_ms;
--				 
----------------------------------------------------
--	Architecture declaration
--	Signals:
--		@slave 		- 16 bit slave stage
--
architecture behv of easy1_reg_ms is
	
	signal slave: std_logic_vector(15 downto 0) := X"0000";
	
begin
	--	Sensitivity List :
	--		This list holds the signals that modify and 
	--		control the register data. This register is
	--		sensitive to the clock source, the load signal,
	--		the clear signal and the input data.
	process(clock,clear,load,input)	 	  
	begin			 
		--	If a clear signal is received assign low to the
		--	output and slave stage.
		if clear = '1' then
			slave <= X"0000"  after DELAY_1_LEVEL;
			o <= X"0000"  after DELAY_1_LEVEL;
		else
			--	Load the input data when the clock is high
			--	and the load signal	has been received.
			if clock = '1' and load = '1' then	   
				slave <= input after DELAY_1_LEVEL;
			--	Show the output when the clock is low.
			elsif clock = '0' then	  
				o <= slave  after DELAY_1_LEVEL;	 
			end if;
		end if;					
		
	end process;
	
end behv;
---------------------------------------------------	
---------------------------------------------------